package utils;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.LinkedHashMap;

/**
 *  
 * @author jwdd
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class Data
{
	public static LinkedHashMap<String, String> ResultSet2LinkedHashMap(String col1, String col2, ResultSet data)
	{
		LinkedHashMap<String, String> lhm = new LinkedHashMap<String, String>();

		String dat1, dat2;

		try
		{
			while (data.next())
			{
				dat1 = data.getString(col1);
				dat2 = data.getString(col2);
				if(data.wasNull())
				{
					dat2 = "";
				}

				lhm.put(dat1, dat2);
			}
		}
		catch (SQLException e)
		{
			e.printStackTrace();
		}

		return lhm;

	}

	public static LinkedHashMap<String, String> ResultSet2LinkedHashMap(String col1, String col2, String col3, ResultSet data)
	{
		LinkedHashMap<String, String> lhm = new LinkedHashMap<String, String>();

		String dat1, dat2, dat3;

		try
		{
			while (data.next())
			{
				dat1 = data.getString(col1);
				dat2 = data.getString(col2);
				dat3 = data.getString(col3);
				if(data.wasNull())
				{
					dat3 = "";
				}

				lhm.put(dat1 + Global.TOKEN_SEPARATOR + dat2, dat3);
			}
		}
		catch (SQLException e)
		{
			e.printStackTrace();
		}

		return lhm;

	}

	public static boolean isEmpty(String str)
	{
		if(str.length() == 0)
		{
			return true;
		}

		return false;
	}
	
	public static String[] buscaItemsLista2(String palabra) 
    {
        ResultSet rs = null;
        ArrayList<String> resultado = new ArrayList<String>();
        String[] resultado2 = null;
        int num = 0;

        try {
            rs = ASyntax.getPict(palabra, 4);
        } catch (Exception e) {
            e.printStackTrace();
        }

        try {
            while (rs.next()) {
                resultado.add(rs.getString("IMG_ID"));
            }

            num = resultado.size();
            resultado2 = new String[num];

            for (int i = 0; i < num; i++) {
                resultado2[i] = resultado.get(i);
            }

        } catch (SQLException e) {
            e.printStackTrace();
        }

        try {
            rs.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return resultado2;
    }

    public static String[] buscaItemsLista(String palabra) // Sobreescribo un método de
    // la clase heredada
    {
        ResultSet rs = null;
        String[] resultado2 = null;
        String[] palabras = null;
        int x = 0, y = 0;
        int npalabras = 0;
        int num = 0;

        palabras = palabra.split(" ", 0);
        npalabras = palabras.length;

        ArrayList<String> resultado = new ArrayList<String>();

        try {
            rs = ASyntax.getPict(palabra, 4);
            while (rs.next()) {
                resultado.add(rs.getString("IMG_ID"));
            }

            while (resultado.size() < 6 && y < 6 && npalabras > 1) {
                y += 1;
                for (int i = 0; i < npalabras; i++) {
                    rs = ASyntax.getPict(palabras[i], 4);
                    x = 0;
                    while (rs.next()) {
                        x += 1;
                        if (x == y) {
                            resultado.add(rs.getString("IMG_ID"));
                        }
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        num = resultado.size();
        resultado2 = new String[num];

        for (int i = 0; i < num; i++) {
            resultado2[i] = resultado.get(i);
        }

        try {
            rs.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return resultado2;
    }
    
    public static LinkedHashMap<String, String> buscaItemsLista(int idUsr)
	{
		ResultSet rs = null;
		LinkedHashMap<String, String> resultado = null;

		try
		{
			rs = DataUsers.getLastDocuments(String.valueOf(idUsr));
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		resultado = Data.ResultSet2LinkedHashMap("ID", "TITLE", "IMG_ID", rs);

		return resultado;
	}

	public static LinkedHashMap<String, String> buscaItemsLista(int idUsr, String texto)
	{
		/*
		 * ResultSet rs = null; LinkedHashMap<String, String> resultado = null;
		 * 
		 * try { rs = DB_actions.getLastDocuments(String.valueOf(idUsr), texto); } catch (Exception e) { e.printStackTrace(); }
		 * 
		 * resultado = Data.ResultSet2LinkedHashMap("TITLE", "IMG_ID", rs);
		 * 
		 * return resultado;
		 */
		LinkedHashMap<String, String> resultado = new LinkedHashMap<String, String>();
		ResultSet rs = null;
		String[] palabras = null;
		int x = 0, y = 0;
		int ndoc = 20;
		int npalabras = 0;
		int num = 0;
		String dat1, dat2;
		palabras = texto.split(" ", 0);
		npalabras = palabras.length;

		try
		{
			rs = DataUsers.getLastDocuments(String.valueOf(idUsr), texto);
			while (rs.next())
			{
				dat1 = rs.getString("TITLE");
				dat2 = rs.getString("IMG_ID");
				if(rs.wasNull())
				{
					dat2 = "";
				}

				resultado.put(dat1, dat2);
			}

			while (resultado.size() <= ndoc && y <= ndoc && npalabras > 1)
			{
				y += 1;
				for (int i = 0; i < npalabras; i++)
				{
					rs = DataUsers.getLastDocuments(String.valueOf(idUsr), palabras[i]);
					x = 0;
					while (rs.next())
					{
						x += 1;
						if(x == y)
						{
							dat1 = rs.getString("TITLE");
							dat2 = rs.getString("IMG_ID");
							if(rs.wasNull())
							{
								dat2 = "6932";
							}
							resultado.put(dat1, dat2);
						}
					}
				}
			}
			rs.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		return resultado;
	}
}
